// Copyright Fuzamei Corp. 2018 All Rights Reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

// Code generated by protoc-gen-go. DO NOT EDIT.
// source: trade.proto

/*
Package types is a generated protocol buffer package.

It is generated from these files:
	trade.proto

It has these top-level messages:
	Trade
	TradeForSell
	TradeForBuy
	TradeForRevokeSell
	TradeForBuyLimit
	TradeForSellMarket
	TradeForRevokeBuy
	SellOrder
	BuyLimitOrder
	ReceiptBuyBase
	ReceiptSellBase
	ReceiptTradeBuyMarket
	ReceiptTradeBuyLimit
	ReceiptTradeBuyRevoke
	ReceiptTradeSellLimit
	ReceiptSellMarket
	ReceiptTradeSellRevoke
	ReqAddrAssets
	ReqTokenSellOrder
	ReqTokenBuyOrder
	ReplyBuyOrder
	ReplySellOrder
	ReplySellOrders
	ReplyBuyOrders
	ReplyTradeOrder
	ReplyTradeOrders
	ReqSellToken
	ReqRevokeSell
	ReqBuyToken
*/
package types

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import types2 "github.com/33cn/chain33/types"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

// trade 交易部分
//
type Trade struct {
	// Types that are valid to be assigned to Value:
	//	*Trade_SellLimit
	//	*Trade_BuyMarket
	//	*Trade_RevokeSell
	//	*Trade_BuyLimit
	//	*Trade_SellMarket
	//	*Trade_RevokeBuy
	Value isTrade_Value `protobuf_oneof:"value"`
	Ty    int32         `protobuf:"varint,4,opt,name=ty" json:"ty,omitempty"`
}

func (m *Trade) Reset()                    { *m = Trade{} }
func (m *Trade) String() string            { return proto.CompactTextString(m) }
func (*Trade) ProtoMessage()               {}
func (*Trade) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

type isTrade_Value interface {
	isTrade_Value()
}

type Trade_SellLimit struct {
	SellLimit *TradeForSell `protobuf:"bytes,1,opt,name=sellLimit,oneof"`
}
type Trade_BuyMarket struct {
	BuyMarket *TradeForBuy `protobuf:"bytes,2,opt,name=buyMarket,oneof"`
}
type Trade_RevokeSell struct {
	RevokeSell *TradeForRevokeSell `protobuf:"bytes,3,opt,name=revokeSell,oneof"`
}
type Trade_BuyLimit struct {
	BuyLimit *TradeForBuyLimit `protobuf:"bytes,5,opt,name=buyLimit,oneof"`
}
type Trade_SellMarket struct {
	SellMarket *TradeForSellMarket `protobuf:"bytes,6,opt,name=sellMarket,oneof"`
}
type Trade_RevokeBuy struct {
	RevokeBuy *TradeForRevokeBuy `protobuf:"bytes,7,opt,name=revokeBuy,oneof"`
}

func (*Trade_SellLimit) isTrade_Value()  {}
func (*Trade_BuyMarket) isTrade_Value()  {}
func (*Trade_RevokeSell) isTrade_Value() {}
func (*Trade_BuyLimit) isTrade_Value()   {}
func (*Trade_SellMarket) isTrade_Value() {}
func (*Trade_RevokeBuy) isTrade_Value()  {}

func (m *Trade) GetValue() isTrade_Value {
	if m != nil {
		return m.Value
	}
	return nil
}

func (m *Trade) GetSellLimit() *TradeForSell {
	if x, ok := m.GetValue().(*Trade_SellLimit); ok {
		return x.SellLimit
	}
	return nil
}

func (m *Trade) GetBuyMarket() *TradeForBuy {
	if x, ok := m.GetValue().(*Trade_BuyMarket); ok {
		return x.BuyMarket
	}
	return nil
}

func (m *Trade) GetRevokeSell() *TradeForRevokeSell {
	if x, ok := m.GetValue().(*Trade_RevokeSell); ok {
		return x.RevokeSell
	}
	return nil
}

func (m *Trade) GetBuyLimit() *TradeForBuyLimit {
	if x, ok := m.GetValue().(*Trade_BuyLimit); ok {
		return x.BuyLimit
	}
	return nil
}

func (m *Trade) GetSellMarket() *TradeForSellMarket {
	if x, ok := m.GetValue().(*Trade_SellMarket); ok {
		return x.SellMarket
	}
	return nil
}

func (m *Trade) GetRevokeBuy() *TradeForRevokeBuy {
	if x, ok := m.GetValue().(*Trade_RevokeBuy); ok {
		return x.RevokeBuy
	}
	return nil
}

func (m *Trade) GetTy() int32 {
	if m != nil {
		return m.Ty
	}
	return 0
}

// XXX_OneofFuncs is for the internal use of the proto package.
func (*Trade) XXX_OneofFuncs() (func(msg proto.Message, b *proto.Buffer) error, func(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error), func(msg proto.Message) (n int), []interface{}) {
	return _Trade_OneofMarshaler, _Trade_OneofUnmarshaler, _Trade_OneofSizer, []interface{}{
		(*Trade_SellLimit)(nil),
		(*Trade_BuyMarket)(nil),
		(*Trade_RevokeSell)(nil),
		(*Trade_BuyLimit)(nil),
		(*Trade_SellMarket)(nil),
		(*Trade_RevokeBuy)(nil),
	}
}

func _Trade_OneofMarshaler(msg proto.Message, b *proto.Buffer) error {
	m := msg.(*Trade)
	// value
	switch x := m.Value.(type) {
	case *Trade_SellLimit:
		b.EncodeVarint(1<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.SellLimit); err != nil {
			return err
		}
	case *Trade_BuyMarket:
		b.EncodeVarint(2<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.BuyMarket); err != nil {
			return err
		}
	case *Trade_RevokeSell:
		b.EncodeVarint(3<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.RevokeSell); err != nil {
			return err
		}
	case *Trade_BuyLimit:
		b.EncodeVarint(5<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.BuyLimit); err != nil {
			return err
		}
	case *Trade_SellMarket:
		b.EncodeVarint(6<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.SellMarket); err != nil {
			return err
		}
	case *Trade_RevokeBuy:
		b.EncodeVarint(7<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.RevokeBuy); err != nil {
			return err
		}
	case nil:
	default:
		return fmt.Errorf("Trade.Value has unexpected type %T", x)
	}
	return nil
}

func _Trade_OneofUnmarshaler(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error) {
	m := msg.(*Trade)
	switch tag {
	case 1: // value.sellLimit
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(TradeForSell)
		err := b.DecodeMessage(msg)
		m.Value = &Trade_SellLimit{msg}
		return true, err
	case 2: // value.buyMarket
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(TradeForBuy)
		err := b.DecodeMessage(msg)
		m.Value = &Trade_BuyMarket{msg}
		return true, err
	case 3: // value.revokeSell
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(TradeForRevokeSell)
		err := b.DecodeMessage(msg)
		m.Value = &Trade_RevokeSell{msg}
		return true, err
	case 5: // value.buyLimit
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(TradeForBuyLimit)
		err := b.DecodeMessage(msg)
		m.Value = &Trade_BuyLimit{msg}
		return true, err
	case 6: // value.sellMarket
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(TradeForSellMarket)
		err := b.DecodeMessage(msg)
		m.Value = &Trade_SellMarket{msg}
		return true, err
	case 7: // value.revokeBuy
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(TradeForRevokeBuy)
		err := b.DecodeMessage(msg)
		m.Value = &Trade_RevokeBuy{msg}
		return true, err
	default:
		return false, nil
	}
}

func _Trade_OneofSizer(msg proto.Message) (n int) {
	m := msg.(*Trade)
	// value
	switch x := m.Value.(type) {
	case *Trade_SellLimit:
		s := proto.Size(x.SellLimit)
		n += proto.SizeVarint(1<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case *Trade_BuyMarket:
		s := proto.Size(x.BuyMarket)
		n += proto.SizeVarint(2<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case *Trade_RevokeSell:
		s := proto.Size(x.RevokeSell)
		n += proto.SizeVarint(3<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case *Trade_BuyLimit:
		s := proto.Size(x.BuyLimit)
		n += proto.SizeVarint(5<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case *Trade_SellMarket:
		s := proto.Size(x.SellMarket)
		n += proto.SizeVarint(6<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case *Trade_RevokeBuy:
		s := proto.Size(x.RevokeBuy)
		n += proto.SizeVarint(7<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case nil:
	default:
		panic(fmt.Sprintf("proto: unexpected type %T in oneof", x))
	}
	return n
}

// 创建众筹交易,确定一手交易的token的数量，单价以及总共有多少手token可以进行众筹
type TradeForSell struct {
	TokenSymbol string `protobuf:"bytes,1,opt,name=tokenSymbol" json:"tokenSymbol,omitempty"`
	// 每一手出售的token的数量
	AmountPerBoardlot int64 `protobuf:"varint,2,opt,name=amountPerBoardlot" json:"amountPerBoardlot,omitempty"`
	// 起卖手数,必须达到这个门槛才允许进行交易
	MinBoardlot int64 `protobuf:"varint,3,opt,name=minBoardlot" json:"minBoardlot,omitempty"`
	// 每一手token的价格
	PricePerBoardlot int64 `protobuf:"varint,4,opt,name=pricePerBoardlot" json:"pricePerBoardlot,omitempty"`
	TotalBoardlot    int64 `protobuf:"varint,5,opt,name=totalBoardlot" json:"totalBoardlot,omitempty"`
	// 此次出售的起始时间，如果非众筹则可以忽略此时间
	Starttime int64 `protobuf:"varint,6,opt,name=starttime" json:"starttime,omitempty"`
	Stoptime  int64 `protobuf:"varint,7,opt,name=stoptime" json:"stoptime,omitempty"`
	Crowdfund bool  `protobuf:"varint,8,opt,name=crowdfund" json:"crowdfund,omitempty"`
	// 资产来源
	AssetExec string `protobuf:"bytes,9,opt,name=assetExec" json:"assetExec,omitempty"`
}

func (m *TradeForSell) Reset()                    { *m = TradeForSell{} }
func (m *TradeForSell) String() string            { return proto.CompactTextString(m) }
func (*TradeForSell) ProtoMessage()               {}
func (*TradeForSell) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *TradeForSell) GetTokenSymbol() string {
	if m != nil {
		return m.TokenSymbol
	}
	return ""
}

func (m *TradeForSell) GetAmountPerBoardlot() int64 {
	if m != nil {
		return m.AmountPerBoardlot
	}
	return 0
}

func (m *TradeForSell) GetMinBoardlot() int64 {
	if m != nil {
		return m.MinBoardlot
	}
	return 0
}

func (m *TradeForSell) GetPricePerBoardlot() int64 {
	if m != nil {
		return m.PricePerBoardlot
	}
	return 0
}

func (m *TradeForSell) GetTotalBoardlot() int64 {
	if m != nil {
		return m.TotalBoardlot
	}
	return 0
}

func (m *TradeForSell) GetStarttime() int64 {
	if m != nil {
		return m.Starttime
	}
	return 0
}

func (m *TradeForSell) GetStoptime() int64 {
	if m != nil {
		return m.Stoptime
	}
	return 0
}

func (m *TradeForSell) GetCrowdfund() bool {
	if m != nil {
		return m.Crowdfund
	}
	return false
}

func (m *TradeForSell) GetAssetExec() string {
	if m != nil {
		return m.AssetExec
	}
	return ""
}

// 购买者发起交易用来购买token持有者之前挂单出售的token
// 其中的hash为token出售者发起出售交易的hash
type TradeForBuy struct {
	SellID      string `protobuf:"bytes,1,opt,name=sellID" json:"sellID,omitempty"`
	BoardlotCnt int64  `protobuf:"varint,2,opt,name=boardlotCnt" json:"boardlotCnt,omitempty"`
}

func (m *TradeForBuy) Reset()                    { *m = TradeForBuy{} }
func (m *TradeForBuy) String() string            { return proto.CompactTextString(m) }
func (*TradeForBuy) ProtoMessage()               {}
func (*TradeForBuy) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func (m *TradeForBuy) GetSellID() string {
	if m != nil {
		return m.SellID
	}
	return ""
}

func (m *TradeForBuy) GetBoardlotCnt() int64 {
	if m != nil {
		return m.BoardlotCnt
	}
	return 0
}

// 允许token的持有者撤销之前未成交出售token的挂单
type TradeForRevokeSell struct {
	SellID string `protobuf:"bytes,1,opt,name=sellID" json:"sellID,omitempty"`
}

func (m *TradeForRevokeSell) Reset()                    { *m = TradeForRevokeSell{} }
func (m *TradeForRevokeSell) String() string            { return proto.CompactTextString(m) }
func (*TradeForRevokeSell) ProtoMessage()               {}
func (*TradeForRevokeSell) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{3} }

func (m *TradeForRevokeSell) GetSellID() string {
	if m != nil {
		return m.SellID
	}
	return ""
}

// 限价买单构造请求
type TradeForBuyLimit struct {
	TokenSymbol       string `protobuf:"bytes,1,opt,name=tokenSymbol" json:"tokenSymbol,omitempty"`
	AmountPerBoardlot int64  `protobuf:"varint,2,opt,name=amountPerBoardlot" json:"amountPerBoardlot,omitempty"`
	MinBoardlot       int64  `protobuf:"varint,3,opt,name=minBoardlot" json:"minBoardlot,omitempty"`
	PricePerBoardlot  int64  `protobuf:"varint,4,opt,name=pricePerBoardlot" json:"pricePerBoardlot,omitempty"`
	TotalBoardlot     int64  `protobuf:"varint,5,opt,name=totalBoardlot" json:"totalBoardlot,omitempty"`
	AssetExec         string `protobuf:"bytes,6,opt,name=assetExec" json:"assetExec,omitempty"`
}

func (m *TradeForBuyLimit) Reset()                    { *m = TradeForBuyLimit{} }
func (m *TradeForBuyLimit) String() string            { return proto.CompactTextString(m) }
func (*TradeForBuyLimit) ProtoMessage()               {}
func (*TradeForBuyLimit) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{4} }

func (m *TradeForBuyLimit) GetTokenSymbol() string {
	if m != nil {
		return m.TokenSymbol
	}
	return ""
}

func (m *TradeForBuyLimit) GetAmountPerBoardlot() int64 {
	if m != nil {
		return m.AmountPerBoardlot
	}
	return 0
}

func (m *TradeForBuyLimit) GetMinBoardlot() int64 {
	if m != nil {
		return m.MinBoardlot
	}
	return 0
}

func (m *TradeForBuyLimit) GetPricePerBoardlot() int64 {
	if m != nil {
		return m.PricePerBoardlot
	}
	return 0
}

func (m *TradeForBuyLimit) GetTotalBoardlot() int64 {
	if m != nil {
		return m.TotalBoardlot
	}
	return 0
}

func (m *TradeForBuyLimit) GetAssetExec() string {
	if m != nil {
		return m.AssetExec
	}
	return ""
}

// 现价卖单
type TradeForSellMarket struct {
	BuyID       string `protobuf:"bytes,1,opt,name=buyID" json:"buyID,omitempty"`
	BoardlotCnt int64  `protobuf:"varint,2,opt,name=boardlotCnt" json:"boardlotCnt,omitempty"`
}

func (m *TradeForSellMarket) Reset()                    { *m = TradeForSellMarket{} }
func (m *TradeForSellMarket) String() string            { return proto.CompactTextString(m) }
func (*TradeForSellMarket) ProtoMessage()               {}
func (*TradeForSellMarket) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{5} }

func (m *TradeForSellMarket) GetBuyID() string {
	if m != nil {
		return m.BuyID
	}
	return ""
}

func (m *TradeForSellMarket) GetBoardlotCnt() int64 {
	if m != nil {
		return m.BoardlotCnt
	}
	return 0
}

// 撤销买单
type TradeForRevokeBuy struct {
	BuyID string `protobuf:"bytes,1,opt,name=buyID" json:"buyID,omitempty"`
}

func (m *TradeForRevokeBuy) Reset()                    { *m = TradeForRevokeBuy{} }
func (m *TradeForRevokeBuy) String() string            { return proto.CompactTextString(m) }
func (*TradeForRevokeBuy) ProtoMessage()               {}
func (*TradeForRevokeBuy) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{6} }

func (m *TradeForRevokeBuy) GetBuyID() string {
	if m != nil {
		return m.BuyID
	}
	return ""
}

// 数据库部分
type SellOrder struct {
	TokenSymbol string `protobuf:"bytes,1,opt,name=tokenSymbol" json:"tokenSymbol,omitempty"`
	Address     string `protobuf:"bytes,2,opt,name=address" json:"address,omitempty"`
	// 每一手出售的token的数量
	AmountPerBoardlot int64 `protobuf:"varint,3,opt,name=amountPerBoardlot" json:"amountPerBoardlot,omitempty"`
	MinBoardlot       int64 `protobuf:"varint,4,opt,name=minBoardlot" json:"minBoardlot,omitempty"`
	// 每一手token的价格
	PricePerBoardlot int64 `protobuf:"varint,5,opt,name=pricePerBoardlot" json:"pricePerBoardlot,omitempty"`
	TotalBoardlot    int64 `protobuf:"varint,6,opt,name=totalBoardlot" json:"totalBoardlot,omitempty"`
	SoldBoardlot     int64 `protobuf:"varint,7,opt,name=soldBoardlot" json:"soldBoardlot,omitempty"`
	// 此次出售的起始时间，如果非众筹则可以忽略此时间
	Starttime int64 `protobuf:"varint,8,opt,name=starttime" json:"starttime,omitempty"`
	Stoptime  int64 `protobuf:"varint,9,opt,name=stoptime" json:"stoptime,omitempty"`
	Crowdfund bool  `protobuf:"varint,10,opt,name=crowdfund" json:"crowdfund,omitempty"`
	// 此处使用tx的hash来指定
	SellID    string `protobuf:"bytes,11,opt,name=sellID" json:"sellID,omitempty"`
	Status    int32  `protobuf:"varint,12,opt,name=status" json:"status,omitempty"`
	Height    int64  `protobuf:"varint,13,opt,name=height" json:"height,omitempty"`
	AssetExec string `protobuf:"bytes,14,opt,name=assetExec" json:"assetExec,omitempty"`
}

func (m *SellOrder) Reset()                    { *m = SellOrder{} }
func (m *SellOrder) String() string            { return proto.CompactTextString(m) }
func (*SellOrder) ProtoMessage()               {}
func (*SellOrder) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{7} }

func (m *SellOrder) GetTokenSymbol() string {
	if m != nil {
		return m.TokenSymbol
	}
	return ""
}

func (m *SellOrder) GetAddress() string {
	if m != nil {
		return m.Address
	}
	return ""
}

func (m *SellOrder) GetAmountPerBoardlot() int64 {
	if m != nil {
		return m.AmountPerBoardlot
	}
	return 0
}

func (m *SellOrder) GetMinBoardlot() int64 {
	if m != nil {
		return m.MinBoardlot
	}
	return 0
}

func (m *SellOrder) GetPricePerBoardlot() int64 {
	if m != nil {
		return m.PricePerBoardlot
	}
	return 0
}

func (m *SellOrder) GetTotalBoardlot() int64 {
	if m != nil {
		return m.TotalBoardlot
	}
	return 0
}

func (m *SellOrder) GetSoldBoardlot() int64 {
	if m != nil {
		return m.SoldBoardlot
	}
	return 0
}

func (m *SellOrder) GetStarttime() int64 {
	if m != nil {
		return m.Starttime
	}
	return 0
}

func (m *SellOrder) GetStoptime() int64 {
	if m != nil {
		return m.Stoptime
	}
	return 0
}

func (m *SellOrder) GetCrowdfund() bool {
	if m != nil {
		return m.Crowdfund
	}
	return false
}

func (m *SellOrder) GetSellID() string {
	if m != nil {
		return m.SellID
	}
	return ""
}

func (m *SellOrder) GetStatus() int32 {
	if m != nil {
		return m.Status
	}
	return 0
}

func (m *SellOrder) GetHeight() int64 {
	if m != nil {
		return m.Height
	}
	return 0
}

func (m *SellOrder) GetAssetExec() string {
	if m != nil {
		return m.AssetExec
	}
	return ""
}

// 限价买单数据库记录
type BuyLimitOrder struct {
	TokenSymbol       string `protobuf:"bytes,1,opt,name=tokenSymbol" json:"tokenSymbol,omitempty"`
	Address           string `protobuf:"bytes,2,opt,name=address" json:"address,omitempty"`
	AmountPerBoardlot int64  `protobuf:"varint,3,opt,name=amountPerBoardlot" json:"amountPerBoardlot,omitempty"`
	MinBoardlot       int64  `protobuf:"varint,4,opt,name=minBoardlot" json:"minBoardlot,omitempty"`
	PricePerBoardlot  int64  `protobuf:"varint,5,opt,name=pricePerBoardlot" json:"pricePerBoardlot,omitempty"`
	TotalBoardlot     int64  `protobuf:"varint,6,opt,name=totalBoardlot" json:"totalBoardlot,omitempty"`
	BoughtBoardlot    int64  `protobuf:"varint,7,opt,name=boughtBoardlot" json:"boughtBoardlot,omitempty"`
	BuyID             string `protobuf:"bytes,8,opt,name=buyID" json:"buyID,omitempty"`
	Status            int32  `protobuf:"varint,9,opt,name=status" json:"status,omitempty"`
	Height            int64  `protobuf:"varint,10,opt,name=height" json:"height,omitempty"`
	AssetExec         string `protobuf:"bytes,11,opt,name=assetExec" json:"assetExec,omitempty"`
}

func (m *BuyLimitOrder) Reset()                    { *m = BuyLimitOrder{} }
func (m *BuyLimitOrder) String() string            { return proto.CompactTextString(m) }
func (*BuyLimitOrder) ProtoMessage()               {}
func (*BuyLimitOrder) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{8} }

func (m *BuyLimitOrder) GetTokenSymbol() string {
	if m != nil {
		return m.TokenSymbol
	}
	return ""
}

func (m *BuyLimitOrder) GetAddress() string {
	if m != nil {
		return m.Address
	}
	return ""
}

func (m *BuyLimitOrder) GetAmountPerBoardlot() int64 {
	if m != nil {
		return m.AmountPerBoardlot
	}
	return 0
}

func (m *BuyLimitOrder) GetMinBoardlot() int64 {
	if m != nil {
		return m.MinBoardlot
	}
	return 0
}

func (m *BuyLimitOrder) GetPricePerBoardlot() int64 {
	if m != nil {
		return m.PricePerBoardlot
	}
	return 0
}

func (m *BuyLimitOrder) GetTotalBoardlot() int64 {
	if m != nil {
		return m.TotalBoardlot
	}
	return 0
}

func (m *BuyLimitOrder) GetBoughtBoardlot() int64 {
	if m != nil {
		return m.BoughtBoardlot
	}
	return 0
}

func (m *BuyLimitOrder) GetBuyID() string {
	if m != nil {
		return m.BuyID
	}
	return ""
}

func (m *BuyLimitOrder) GetStatus() int32 {
	if m != nil {
		return m.Status
	}
	return 0
}

func (m *BuyLimitOrder) GetHeight() int64 {
	if m != nil {
		return m.Height
	}
	return 0
}

func (m *BuyLimitOrder) GetAssetExec() string {
	if m != nil {
		return m.AssetExec
	}
	return ""
}

// 执行器日志部分
type ReceiptBuyBase struct {
	TokenSymbol       string `protobuf:"bytes,1,opt,name=tokenSymbol" json:"tokenSymbol,omitempty"`
	Owner             string `protobuf:"bytes,2,opt,name=owner" json:"owner,omitempty"`
	AmountPerBoardlot string `protobuf:"bytes,3,opt,name=amountPerBoardlot" json:"amountPerBoardlot,omitempty"`
	MinBoardlot       int64  `protobuf:"varint,4,opt,name=minBoardlot" json:"minBoardlot,omitempty"`
	PricePerBoardlot  string `protobuf:"bytes,5,opt,name=pricePerBoardlot" json:"pricePerBoardlot,omitempty"`
	TotalBoardlot     int64  `protobuf:"varint,6,opt,name=totalBoardlot" json:"totalBoardlot,omitempty"`
	BoughtBoardlot    int64  `protobuf:"varint,7,opt,name=boughtBoardlot" json:"boughtBoardlot,omitempty"`
	BuyID             string `protobuf:"bytes,8,opt,name=buyID" json:"buyID,omitempty"`
	Status            string `protobuf:"bytes,9,opt,name=status" json:"status,omitempty"`
	SellID            string `protobuf:"bytes,10,opt,name=sellID" json:"sellID,omitempty"`
	TxHash            string `protobuf:"bytes,11,opt,name=txHash" json:"txHash,omitempty"`
	Height            int64  `protobuf:"varint,12,opt,name=height" json:"height,omitempty"`
	AssetExec         string `protobuf:"bytes,13,opt,name=assetExec" json:"assetExec,omitempty"`
}

func (m *ReceiptBuyBase) Reset()                    { *m = ReceiptBuyBase{} }
func (m *ReceiptBuyBase) String() string            { return proto.CompactTextString(m) }
func (*ReceiptBuyBase) ProtoMessage()               {}
func (*ReceiptBuyBase) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{9} }

func (m *ReceiptBuyBase) GetTokenSymbol() string {
	if m != nil {
		return m.TokenSymbol
	}
	return ""
}

func (m *ReceiptBuyBase) GetOwner() string {
	if m != nil {
		return m.Owner
	}
	return ""
}

func (m *ReceiptBuyBase) GetAmountPerBoardlot() string {
	if m != nil {
		return m.AmountPerBoardlot
	}
	return ""
}

func (m *ReceiptBuyBase) GetMinBoardlot() int64 {
	if m != nil {
		return m.MinBoardlot
	}
	return 0
}

func (m *ReceiptBuyBase) GetPricePerBoardlot() string {
	if m != nil {
		return m.PricePerBoardlot
	}
	return ""
}

func (m *ReceiptBuyBase) GetTotalBoardlot() int64 {
	if m != nil {
		return m.TotalBoardlot
	}
	return 0
}

func (m *ReceiptBuyBase) GetBoughtBoardlot() int64 {
	if m != nil {
		return m.BoughtBoardlot
	}
	return 0
}

func (m *ReceiptBuyBase) GetBuyID() string {
	if m != nil {
		return m.BuyID
	}
	return ""
}

func (m *ReceiptBuyBase) GetStatus() string {
	if m != nil {
		return m.Status
	}
	return ""
}

func (m *ReceiptBuyBase) GetSellID() string {
	if m != nil {
		return m.SellID
	}
	return ""
}

func (m *ReceiptBuyBase) GetTxHash() string {
	if m != nil {
		return m.TxHash
	}
	return ""
}

func (m *ReceiptBuyBase) GetHeight() int64 {
	if m != nil {
		return m.Height
	}
	return 0
}

func (m *ReceiptBuyBase) GetAssetExec() string {
	if m != nil {
		return m.AssetExec
	}
	return ""
}

type ReceiptSellBase struct {
	TokenSymbol string `protobuf:"bytes,1,opt,name=tokenSymbol" json:"tokenSymbol,omitempty"`
	Owner       string `protobuf:"bytes,2,opt,name=owner" json:"owner,omitempty"`
	// 每一手出售的token的数量
	AmountPerBoardlot string `protobuf:"bytes,3,opt,name=amountPerBoardlot" json:"amountPerBoardlot,omitempty"`
	MinBoardlot       int64  `protobuf:"varint,4,opt,name=minBoardlot" json:"minBoardlot,omitempty"`
	// 每一手token的价格
	PricePerBoardlot string `protobuf:"bytes,5,opt,name=pricePerBoardlot" json:"pricePerBoardlot,omitempty"`
	TotalBoardlot    int64  `protobuf:"varint,6,opt,name=totalBoardlot" json:"totalBoardlot,omitempty"`
	SoldBoardlot     int64  `protobuf:"varint,7,opt,name=soldBoardlot" json:"soldBoardlot,omitempty"`
	// 此次出售的起始时间，如果非众筹则可以忽略此时间
	Starttime int64 `protobuf:"varint,8,opt,name=starttime" json:"starttime,omitempty"`
	Stoptime  int64 `protobuf:"varint,9,opt,name=stoptime" json:"stoptime,omitempty"`
	Crowdfund bool  `protobuf:"varint,10,opt,name=crowdfund" json:"crowdfund,omitempty"`
	// 此处使用tx的hash来指定
	SellID string `protobuf:"bytes,11,opt,name=sellID" json:"sellID,omitempty"`
	Status string `protobuf:"bytes,12,opt,name=status" json:"status,omitempty"`
	// buyid
	BuyID     string `protobuf:"bytes,13,opt,name=buyID" json:"buyID,omitempty"`
	TxHash    string `protobuf:"bytes,14,opt,name=txHash" json:"txHash,omitempty"`
	Height    int64  `protobuf:"varint,15,opt,name=height" json:"height,omitempty"`
	AssetExec string `protobuf:"bytes,16,opt,name=assetExec" json:"assetExec,omitempty"`
}

func (m *ReceiptSellBase) Reset()                    { *m = ReceiptSellBase{} }
func (m *ReceiptSellBase) String() string            { return proto.CompactTextString(m) }
func (*ReceiptSellBase) ProtoMessage()               {}
func (*ReceiptSellBase) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{10} }

func (m *ReceiptSellBase) GetTokenSymbol() string {
	if m != nil {
		return m.TokenSymbol
	}
	return ""
}

func (m *ReceiptSellBase) GetOwner() string {
	if m != nil {
		return m.Owner
	}
	return ""
}

func (m *ReceiptSellBase) GetAmountPerBoardlot() string {
	if m != nil {
		return m.AmountPerBoardlot
	}
	return ""
}

func (m *ReceiptSellBase) GetMinBoardlot() int64 {
	if m != nil {
		return m.MinBoardlot
	}
	return 0
}

func (m *ReceiptSellBase) GetPricePerBoardlot() string {
	if m != nil {
		return m.PricePerBoardlot
	}
	return ""
}

func (m *ReceiptSellBase) GetTotalBoardlot() int64 {
	if m != nil {
		return m.TotalBoardlot
	}
	return 0
}

func (m *ReceiptSellBase) GetSoldBoardlot() int64 {
	if m != nil {
		return m.SoldBoardlot
	}
	return 0
}

func (m *ReceiptSellBase) GetStarttime() int64 {
	if m != nil {
		return m.Starttime
	}
	return 0
}

func (m *ReceiptSellBase) GetStoptime() int64 {
	if m != nil {
		return m.Stoptime
	}
	return 0
}

func (m *ReceiptSellBase) GetCrowdfund() bool {
	if m != nil {
		return m.Crowdfund
	}
	return false
}

func (m *ReceiptSellBase) GetSellID() string {
	if m != nil {
		return m.SellID
	}
	return ""
}

func (m *ReceiptSellBase) GetStatus() string {
	if m != nil {
		return m.Status
	}
	return ""
}

func (m *ReceiptSellBase) GetBuyID() string {
	if m != nil {
		return m.BuyID
	}
	return ""
}

func (m *ReceiptSellBase) GetTxHash() string {
	if m != nil {
		return m.TxHash
	}
	return ""
}

func (m *ReceiptSellBase) GetHeight() int64 {
	if m != nil {
		return m.Height
	}
	return 0
}

func (m *ReceiptSellBase) GetAssetExec() string {
	if m != nil {
		return m.AssetExec
	}
	return ""
}

type ReceiptTradeBuyMarket struct {
	Base *ReceiptBuyBase `protobuf:"bytes,1,opt,name=base" json:"base,omitempty"`
}

func (m *ReceiptTradeBuyMarket) Reset()                    { *m = ReceiptTradeBuyMarket{} }
func (m *ReceiptTradeBuyMarket) String() string            { return proto.CompactTextString(m) }
func (*ReceiptTradeBuyMarket) ProtoMessage()               {}
func (*ReceiptTradeBuyMarket) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{11} }

func (m *ReceiptTradeBuyMarket) GetBase() *ReceiptBuyBase {
	if m != nil {
		return m.Base
	}
	return nil
}

type ReceiptTradeBuyLimit struct {
	Base *ReceiptBuyBase `protobuf:"bytes,1,opt,name=base" json:"base,omitempty"`
}

func (m *ReceiptTradeBuyLimit) Reset()                    { *m = ReceiptTradeBuyLimit{} }
func (m *ReceiptTradeBuyLimit) String() string            { return proto.CompactTextString(m) }
func (*ReceiptTradeBuyLimit) ProtoMessage()               {}
func (*ReceiptTradeBuyLimit) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{12} }

func (m *ReceiptTradeBuyLimit) GetBase() *ReceiptBuyBase {
	if m != nil {
		return m.Base
	}
	return nil
}

type ReceiptTradeBuyRevoke struct {
	Base *ReceiptBuyBase `protobuf:"bytes,1,opt,name=base" json:"base,omitempty"`
}

func (m *ReceiptTradeBuyRevoke) Reset()                    { *m = ReceiptTradeBuyRevoke{} }
func (m *ReceiptTradeBuyRevoke) String() string            { return proto.CompactTextString(m) }
func (*ReceiptTradeBuyRevoke) ProtoMessage()               {}
func (*ReceiptTradeBuyRevoke) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{13} }

func (m *ReceiptTradeBuyRevoke) GetBase() *ReceiptBuyBase {
	if m != nil {
		return m.Base
	}
	return nil
}

type ReceiptTradeSellLimit struct {
	Base *ReceiptSellBase `protobuf:"bytes,1,opt,name=base" json:"base,omitempty"`
}

func (m *ReceiptTradeSellLimit) Reset()                    { *m = ReceiptTradeSellLimit{} }
func (m *ReceiptTradeSellLimit) String() string            { return proto.CompactTextString(m) }
func (*ReceiptTradeSellLimit) ProtoMessage()               {}
func (*ReceiptTradeSellLimit) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{14} }

func (m *ReceiptTradeSellLimit) GetBase() *ReceiptSellBase {
	if m != nil {
		return m.Base
	}
	return nil
}

type ReceiptSellMarket struct {
	Base *ReceiptSellBase `protobuf:"bytes,1,opt,name=base" json:"base,omitempty"`
}

func (m *ReceiptSellMarket) Reset()                    { *m = ReceiptSellMarket{} }
func (m *ReceiptSellMarket) String() string            { return proto.CompactTextString(m) }
func (*ReceiptSellMarket) ProtoMessage()               {}
func (*ReceiptSellMarket) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{15} }

func (m *ReceiptSellMarket) GetBase() *ReceiptSellBase {
	if m != nil {
		return m.Base
	}
	return nil
}

type ReceiptTradeSellRevoke struct {
	Base *ReceiptSellBase `protobuf:"bytes,1,opt,name=base" json:"base,omitempty"`
}

func (m *ReceiptTradeSellRevoke) Reset()                    { *m = ReceiptTradeSellRevoke{} }
func (m *ReceiptTradeSellRevoke) String() string            { return proto.CompactTextString(m) }
func (*ReceiptTradeSellRevoke) ProtoMessage()               {}
func (*ReceiptTradeSellRevoke) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{16} }

func (m *ReceiptTradeSellRevoke) GetBase() *ReceiptSellBase {
	if m != nil {
		return m.Base
	}
	return nil
}

type ReqAddrAssets struct {
	Addr   string `protobuf:"bytes,1,opt,name=addr" json:"addr,omitempty"`
	Status int32  `protobuf:"varint,2,opt,name=status" json:"status,omitempty"`
	// ??
	Token     []string `protobuf:"bytes,3,rep,name=token" json:"token,omitempty"`
	Direction int32    `protobuf:"varint,4,opt,name=direction" json:"direction,omitempty"`
	Count     int32    `protobuf:"varint,5,opt,name=count" json:"count,omitempty"`
	FromKey   string   `protobuf:"bytes,6,opt,name=fromKey" json:"fromKey,omitempty"`
}

func (m *ReqAddrAssets) Reset()                    { *m = ReqAddrAssets{} }
func (m *ReqAddrAssets) String() string            { return proto.CompactTextString(m) }
func (*ReqAddrAssets) ProtoMessage()               {}
func (*ReqAddrAssets) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{17} }

func (m *ReqAddrAssets) GetAddr() string {
	if m != nil {
		return m.Addr
	}
	return ""
}

func (m *ReqAddrAssets) GetStatus() int32 {
	if m != nil {
		return m.Status
	}
	return 0
}

func (m *ReqAddrAssets) GetToken() []string {
	if m != nil {
		return m.Token
	}
	return nil
}

func (m *ReqAddrAssets) GetDirection() int32 {
	if m != nil {
		return m.Direction
	}
	return 0
}

func (m *ReqAddrAssets) GetCount() int32 {
	if m != nil {
		return m.Count
	}
	return 0
}

func (m *ReqAddrAssets) GetFromKey() string {
	if m != nil {
		return m.FromKey
	}
	return ""
}

// 获取Token未完成卖单的交易列表
// 	 fromKey : 第一次传参为空，获取卖单单价最低的列表。 当要获得下一页时，
// 传当前页最后一个；当要获得上一页时， 传当前页第一个。 	 count
// :获取交易列表的个数。 	 direction :查找方式；0，上一页；1，下一页。
// 越靠后的也单价越贵
type ReqTokenSellOrder struct {
	TokenSymbol string `protobuf:"bytes,1,opt,name=tokenSymbol" json:"tokenSymbol,omitempty"`
	FromKey     string `protobuf:"bytes,2,opt,name=fromKey" json:"fromKey,omitempty"`
	Count       int32  `protobuf:"varint,3,opt,name=count" json:"count,omitempty"`
	Direction   int32  `protobuf:"varint,4,opt,name=direction" json:"direction,omitempty"`
	Status      int32  `protobuf:"varint,5,opt,name=status" json:"status,omitempty"`
}

func (m *ReqTokenSellOrder) Reset()                    { *m = ReqTokenSellOrder{} }
func (m *ReqTokenSellOrder) String() string            { return proto.CompactTextString(m) }
func (*ReqTokenSellOrder) ProtoMessage()               {}
func (*ReqTokenSellOrder) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{18} }

func (m *ReqTokenSellOrder) GetTokenSymbol() string {
	if m != nil {
		return m.TokenSymbol
	}
	return ""
}

func (m *ReqTokenSellOrder) GetFromKey() string {
	if m != nil {
		return m.FromKey
	}
	return ""
}

func (m *ReqTokenSellOrder) GetCount() int32 {
	if m != nil {
		return m.Count
	}
	return 0
}

func (m *ReqTokenSellOrder) GetDirection() int32 {
	if m != nil {
		return m.Direction
	}
	return 0
}

func (m *ReqTokenSellOrder) GetStatus() int32 {
	if m != nil {
		return m.Status
	}
	return 0
}

type ReqTokenBuyOrder struct {
	TokenSymbol string `protobuf:"bytes,1,opt,name=tokenSymbol" json:"tokenSymbol,omitempty"`
	FromKey     string `protobuf:"bytes,2,opt,name=fromKey" json:"fromKey,omitempty"`
	Count       int32  `protobuf:"varint,3,opt,name=count" json:"count,omitempty"`
	Direction   int32  `protobuf:"varint,4,opt,name=direction" json:"direction,omitempty"`
	Status      int32  `protobuf:"varint,5,opt,name=status" json:"status,omitempty"`
}

func (m *ReqTokenBuyOrder) Reset()                    { *m = ReqTokenBuyOrder{} }
func (m *ReqTokenBuyOrder) String() string            { return proto.CompactTextString(m) }
func (*ReqTokenBuyOrder) ProtoMessage()               {}
func (*ReqTokenBuyOrder) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{19} }

func (m *ReqTokenBuyOrder) GetTokenSymbol() string {
	if m != nil {
		return m.TokenSymbol
	}
	return ""
}

func (m *ReqTokenBuyOrder) GetFromKey() string {
	if m != nil {
		return m.FromKey
	}
	return ""
}

func (m *ReqTokenBuyOrder) GetCount() int32 {
	if m != nil {
		return m.Count
	}
	return 0
}

func (m *ReqTokenBuyOrder) GetDirection() int32 {
	if m != nil {
		return m.Direction
	}
	return 0
}

func (m *ReqTokenBuyOrder) GetStatus() int32 {
	if m != nil {
		return m.Status
	}
	return 0
}

type ReplyBuyOrder struct {
	TokenSymbol       string `protobuf:"bytes,1,opt,name=tokenSymbol" json:"tokenSymbol,omitempty"`
	Owner             string `protobuf:"bytes,2,opt,name=owner" json:"owner,omitempty"`
	AmountPerBoardlot int64  `protobuf:"varint,3,opt,name=amountPerBoardlot" json:"amountPerBoardlot,omitempty"`
	MinBoardlot       int64  `protobuf:"varint,4,opt,name=minBoardlot" json:"minBoardlot,omitempty"`
	PricePerBoardlot  int64  `protobuf:"varint,5,opt,name=pricePerBoardlot" json:"pricePerBoardlot,omitempty"`
	TotalBoardlot     int64  `protobuf:"varint,6,opt,name=totalBoardlot" json:"totalBoardlot,omitempty"`
	BoughtBoardlot    int64  `protobuf:"varint,7,opt,name=boughtBoardlot" json:"boughtBoardlot,omitempty"`
	BuyID             string `protobuf:"bytes,8,opt,name=buyID" json:"buyID,omitempty"`
	Status            int32  `protobuf:"varint,9,opt,name=status" json:"status,omitempty"`
	SellID            string `protobuf:"bytes,10,opt,name=sellID" json:"sellID,omitempty"`
	TxHash            string `protobuf:"bytes,11,opt,name=txHash" json:"txHash,omitempty"`
	Height            int64  `protobuf:"varint,12,opt,name=height" json:"height,omitempty"`
	Key               string `protobuf:"bytes,13,opt,name=key" json:"key,omitempty"`
	AssetExec         string `protobuf:"bytes,14,opt,name=assetExec" json:"assetExec,omitempty"`
}

func (m *ReplyBuyOrder) Reset()                    { *m = ReplyBuyOrder{} }
func (m *ReplyBuyOrder) String() string            { return proto.CompactTextString(m) }
func (*ReplyBuyOrder) ProtoMessage()               {}
func (*ReplyBuyOrder) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{20} }

func (m *ReplyBuyOrder) GetTokenSymbol() string {
	if m != nil {
		return m.TokenSymbol
	}
	return ""
}

func (m *ReplyBuyOrder) GetOwner() string {
	if m != nil {
		return m.Owner
	}
	return ""
}

func (m *ReplyBuyOrder) GetAmountPerBoardlot() int64 {
	if m != nil {
		return m.AmountPerBoardlot
	}
	return 0
}

func (m *ReplyBuyOrder) GetMinBoardlot() int64 {
	if m != nil {
		return m.MinBoardlot
	}
	return 0
}

func (m *ReplyBuyOrder) GetPricePerBoardlot() int64 {
	if m != nil {
		return m.PricePerBoardlot
	}
	return 0
}

func (m *ReplyBuyOrder) GetTotalBoardlot() int64 {
	if m != nil {
		return m.TotalBoardlot
	}
	return 0
}

func (m *ReplyBuyOrder) GetBoughtBoardlot() int64 {
	if m != nil {
		return m.BoughtBoardlot
	}
	return 0
}

func (m *ReplyBuyOrder) GetBuyID() string {
	if m != nil {
		return m.BuyID
	}
	return ""
}

func (m *ReplyBuyOrder) GetStatus() int32 {
	if m != nil {
		return m.Status
	}
	return 0
}

func (m *ReplyBuyOrder) GetSellID() string {
	if m != nil {
		return m.SellID
	}
	return ""
}

func (m *ReplyBuyOrder) GetTxHash() string {
	if m != nil {
		return m.TxHash
	}
	return ""
}

func (m *ReplyBuyOrder) GetHeight() int64 {
	if m != nil {
		return m.Height
	}
	return 0
}

func (m *ReplyBuyOrder) GetKey() string {
	if m != nil {
		return m.Key
	}
	return ""
}

func (m *ReplyBuyOrder) GetAssetExec() string {
	if m != nil {
		return m.AssetExec
	}
	return ""
}

type ReplySellOrder struct {
	TokenSymbol       string `protobuf:"bytes,1,opt,name=tokenSymbol" json:"tokenSymbol,omitempty"`
	Owner             string `protobuf:"bytes,2,opt,name=owner" json:"owner,omitempty"`
	AmountPerBoardlot int64  `protobuf:"varint,3,opt,name=amountPerBoardlot" json:"amountPerBoardlot,omitempty"`
	MinBoardlot       int64  `protobuf:"varint,4,opt,name=minBoardlot" json:"minBoardlot,omitempty"`
	PricePerBoardlot  int64  `protobuf:"varint,5,opt,name=pricePerBoardlot" json:"pricePerBoardlot,omitempty"`
	TotalBoardlot     int64  `protobuf:"varint,6,opt,name=totalBoardlot" json:"totalBoardlot,omitempty"`
	SoldBoardlot      int64  `protobuf:"varint,7,opt,name=soldBoardlot" json:"soldBoardlot,omitempty"`
	BuyID             string `protobuf:"bytes,8,opt,name=buyID" json:"buyID,omitempty"`
	Status            int32  `protobuf:"varint,9,opt,name=status" json:"status,omitempty"`
	SellID            string `protobuf:"bytes,10,opt,name=sellID" json:"sellID,omitempty"`
	TxHash            string `protobuf:"bytes,11,opt,name=txHash" json:"txHash,omitempty"`
	Height            int64  `protobuf:"varint,12,opt,name=height" json:"height,omitempty"`
	Key               string `protobuf:"bytes,13,opt,name=key" json:"key,omitempty"`
	AssetExec         string `protobuf:"bytes,14,opt,name=assetExec" json:"assetExec,omitempty"`
}

func (m *ReplySellOrder) Reset()                    { *m = ReplySellOrder{} }
func (m *ReplySellOrder) String() string            { return proto.CompactTextString(m) }
func (*ReplySellOrder) ProtoMessage()               {}
func (*ReplySellOrder) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{21} }

func (m *ReplySellOrder) GetTokenSymbol() string {
	if m != nil {
		return m.TokenSymbol
	}
	return ""
}

func (m *ReplySellOrder) GetOwner() string {
	if m != nil {
		return m.Owner
	}
	return ""
}

func (m *ReplySellOrder) GetAmountPerBoardlot() int64 {
	if m != nil {
		return m.AmountPerBoardlot
	}
	return 0
}

func (m *ReplySellOrder) GetMinBoardlot() int64 {
	if m != nil {
		return m.MinBoardlot
	}
	return 0
}

func (m *ReplySellOrder) GetPricePerBoardlot() int64 {
	if m != nil {
		return m.PricePerBoardlot
	}
	return 0
}

func (m *ReplySellOrder) GetTotalBoardlot() int64 {
	if m != nil {
		return m.TotalBoardlot
	}
	return 0
}

func (m *ReplySellOrder) GetSoldBoardlot() int64 {
	if m != nil {
		return m.SoldBoardlot
	}
	return 0
}

func (m *ReplySellOrder) GetBuyID() string {
	if m != nil {
		return m.BuyID
	}
	return ""
}

func (m *ReplySellOrder) GetStatus() int32 {
	if m != nil {
		return m.Status
	}
	return 0
}

func (m *ReplySellOrder) GetSellID() string {
	if m != nil {
		return m.SellID
	}
	return ""
}

func (m *ReplySellOrder) GetTxHash() string {
	if m != nil {
		return m.TxHash
	}
	return ""
}

func (m *ReplySellOrder) GetHeight() int64 {
	if m != nil {
		return m.Height
	}
	return 0
}

func (m *ReplySellOrder) GetKey() string {
	if m != nil {
		return m.Key
	}
	return ""
}

func (m *ReplySellOrder) GetAssetExec() string {
	if m != nil {
		return m.AssetExec
	}
	return ""
}

type ReplySellOrders struct {
	SellOrders []*ReplySellOrder `protobuf:"bytes,1,rep,name=sellOrders" json:"sellOrders,omitempty"`
}

func (m *ReplySellOrders) Reset()                    { *m = ReplySellOrders{} }
func (m *ReplySellOrders) String() string            { return proto.CompactTextString(m) }
func (*ReplySellOrders) ProtoMessage()               {}
func (*ReplySellOrders) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{22} }

func (m *ReplySellOrders) GetSellOrders() []*ReplySellOrder {
	if m != nil {
		return m.SellOrders
	}
	return nil
}

type ReplyBuyOrders struct {
	BuyOrders []*ReplyBuyOrder `protobuf:"bytes,1,rep,name=buyOrders" json:"buyOrders,omitempty"`
}

func (m *ReplyBuyOrders) Reset()                    { *m = ReplyBuyOrders{} }
func (m *ReplyBuyOrders) String() string            { return proto.CompactTextString(m) }
func (*ReplyBuyOrders) ProtoMessage()               {}
func (*ReplyBuyOrders) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{23} }

func (m *ReplyBuyOrders) GetBuyOrders() []*ReplyBuyOrder {
	if m != nil {
		return m.BuyOrders
	}
	return nil
}

type ReplyTradeOrder struct {
	TokenSymbol       string `protobuf:"bytes,1,opt,name=tokenSymbol" json:"tokenSymbol,omitempty"`
	Owner             string `protobuf:"bytes,2,opt,name=owner" json:"owner,omitempty"`
	AmountPerBoardlot int64  `protobuf:"varint,3,opt,name=amountPerBoardlot" json:"amountPerBoardlot,omitempty"`
	MinBoardlot       int64  `protobuf:"varint,4,opt,name=minBoardlot" json:"minBoardlot,omitempty"`
	PricePerBoardlot  int64  `protobuf:"varint,5,opt,name=pricePerBoardlot" json:"pricePerBoardlot,omitempty"`
	TotalBoardlot     int64  `protobuf:"varint,6,opt,name=totalBoardlot" json:"totalBoardlot,omitempty"`
	TradedBoardlot    int64  `protobuf:"varint,7,opt,name=tradedBoardlot" json:"tradedBoardlot,omitempty"`
	BuyID             string `protobuf:"bytes,8,opt,name=buyID" json:"buyID,omitempty"`
	Status            int32  `protobuf:"varint,9,opt,name=status" json:"status,omitempty"`
	SellID            string `protobuf:"bytes,10,opt,name=sellID" json:"sellID,omitempty"`
	TxHash            string `protobuf:"bytes,11,opt,name=txHash" json:"txHash,omitempty"`
	Height            int64  `protobuf:"varint,12,opt,name=height" json:"height,omitempty"`
	Key               string `protobuf:"bytes,13,opt,name=key" json:"key,omitempty"`
	BlockTime         int64  `protobuf:"varint,14,opt,name=blockTime" json:"blockTime,omitempty"`
	IsSellOrder       bool   `protobuf:"varint,15,opt,name=isSellOrder" json:"isSellOrder,omitempty"`
	AssetExec         string `protobuf:"bytes,16,opt,name=assetExec" json:"assetExec,omitempty"`
}

func (m *ReplyTradeOrder) Reset()                    { *m = ReplyTradeOrder{} }
func (m *ReplyTradeOrder) String() string            { return proto.CompactTextString(m) }
func (*ReplyTradeOrder) ProtoMessage()               {}
func (*ReplyTradeOrder) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{24} }

func (m *ReplyTradeOrder) GetTokenSymbol() string {
	if m != nil {
		return m.TokenSymbol
	}
	return ""
}

func (m *ReplyTradeOrder) GetOwner() string {
	if m != nil {
		return m.Owner
	}
	return ""
}

func (m *ReplyTradeOrder) GetAmountPerBoardlot() int64 {
	if m != nil {
		return m.AmountPerBoardlot
	}
	return 0
}

func (m *ReplyTradeOrder) GetMinBoardlot() int64 {
	if m != nil {
		return m.MinBoardlot
	}
	return 0
}

func (m *ReplyTradeOrder) GetPricePerBoardlot() int64 {
	if m != nil {
		return m.PricePerBoardlot
	}
	return 0
}

func (m *ReplyTradeOrder) GetTotalBoardlot() int64 {
	if m != nil {
		return m.TotalBoardlot
	}
	return 0
}

func (m *ReplyTradeOrder) GetTradedBoardlot() int64 {
	if m != nil {
		return m.TradedBoardlot
	}
	return 0
}

func (m *ReplyTradeOrder) GetBuyID() string {
	if m != nil {
		return m.BuyID
	}
	return ""
}

func (m *ReplyTradeOrder) GetStatus() int32 {
	if m != nil {
		return m.Status
	}
	return 0
}

func (m *ReplyTradeOrder) GetSellID() string {
	if m != nil {
		return m.SellID
	}
	return ""
}

func (m *ReplyTradeOrder) GetTxHash() string {
	if m != nil {
		return m.TxHash
	}
	return ""
}

func (m *ReplyTradeOrder) GetHeight() int64 {
	if m != nil {
		return m.Height
	}
	return 0
}

func (m *ReplyTradeOrder) GetKey() string {
	if m != nil {
		return m.Key
	}
	return ""
}

func (m *ReplyTradeOrder) GetBlockTime() int64 {
	if m != nil {
		return m.BlockTime
	}
	return 0
}

func (m *ReplyTradeOrder) GetIsSellOrder() bool {
	if m != nil {
		return m.IsSellOrder
	}
	return false
}

func (m *ReplyTradeOrder) GetAssetExec() string {
	if m != nil {
		return m.AssetExec
	}
	return ""
}

type ReplyTradeOrders struct {
	Orders []*ReplyTradeOrder `protobuf:"bytes,1,rep,name=orders" json:"orders,omitempty"`
}

func (m *ReplyTradeOrders) Reset()                    { *m = ReplyTradeOrders{} }
func (m *ReplyTradeOrders) String() string            { return proto.CompactTextString(m) }
func (*ReplyTradeOrders) ProtoMessage()               {}
func (*ReplyTradeOrders) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{25} }

func (m *ReplyTradeOrders) GetOrders() []*ReplyTradeOrder {
	if m != nil {
		return m.Orders
	}
	return nil
}

type ReqSellToken struct {
	Sell  *TradeForSell `protobuf:"bytes,1,opt,name=sell" json:"sell,omitempty"`
	Owner string        `protobuf:"bytes,2,opt,name=owner" json:"owner,omitempty"`
}

func (m *ReqSellToken) Reset()                    { *m = ReqSellToken{} }
func (m *ReqSellToken) String() string            { return proto.CompactTextString(m) }
func (*ReqSellToken) ProtoMessage()               {}
func (*ReqSellToken) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{26} }

func (m *ReqSellToken) GetSell() *TradeForSell {
	if m != nil {
		return m.Sell
	}
	return nil
}

func (m *ReqSellToken) GetOwner() string {
	if m != nil {
		return m.Owner
	}
	return ""
}

type ReqRevokeSell struct {
	Revoke *TradeForRevokeSell `protobuf:"bytes,1,opt,name=revoke" json:"revoke,omitempty"`
	Owner  string              `protobuf:"bytes,2,opt,name=owner" json:"owner,omitempty"`
}

func (m *ReqRevokeSell) Reset()                    { *m = ReqRevokeSell{} }
func (m *ReqRevokeSell) String() string            { return proto.CompactTextString(m) }
func (*ReqRevokeSell) ProtoMessage()               {}
func (*ReqRevokeSell) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{27} }

func (m *ReqRevokeSell) GetRevoke() *TradeForRevokeSell {
	if m != nil {
		return m.Revoke
	}
	return nil
}

func (m *ReqRevokeSell) GetOwner() string {
	if m != nil {
		return m.Owner
	}
	return ""
}

type ReqBuyToken struct {
	Buy   *TradeForBuy `protobuf:"bytes,1,opt,name=buy" json:"buy,omitempty"`
	Buyer string       `protobuf:"bytes,2,opt,name=buyer" json:"buyer,omitempty"`
}

func (m *ReqBuyToken) Reset()                    { *m = ReqBuyToken{} }
func (m *ReqBuyToken) String() string            { return proto.CompactTextString(m) }
func (*ReqBuyToken) ProtoMessage()               {}
func (*ReqBuyToken) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{28} }

func (m *ReqBuyToken) GetBuy() *TradeForBuy {
	if m != nil {
		return m.Buy
	}
	return nil
}

func (m *ReqBuyToken) GetBuyer() string {
	if m != nil {
		return m.Buyer
	}
	return ""
}

func init() {
	proto.RegisterType((*Trade)(nil), "types.Trade")
	proto.RegisterType((*TradeForSell)(nil), "types.TradeForSell")
	proto.RegisterType((*TradeForBuy)(nil), "types.TradeForBuy")
	proto.RegisterType((*TradeForRevokeSell)(nil), "types.TradeForRevokeSell")
	proto.RegisterType((*TradeForBuyLimit)(nil), "types.TradeForBuyLimit")
	proto.RegisterType((*TradeForSellMarket)(nil), "types.TradeForSellMarket")
	proto.RegisterType((*TradeForRevokeBuy)(nil), "types.TradeForRevokeBuy")
	proto.RegisterType((*SellOrder)(nil), "types.SellOrder")
	proto.RegisterType((*BuyLimitOrder)(nil), "types.BuyLimitOrder")
	proto.RegisterType((*ReceiptBuyBase)(nil), "types.ReceiptBuyBase")
	proto.RegisterType((*ReceiptSellBase)(nil), "types.ReceiptSellBase")
	proto.RegisterType((*ReceiptTradeBuyMarket)(nil), "types.ReceiptTradeBuyMarket")
	proto.RegisterType((*ReceiptTradeBuyLimit)(nil), "types.ReceiptTradeBuyLimit")
	proto.RegisterType((*ReceiptTradeBuyRevoke)(nil), "types.ReceiptTradeBuyRevoke")
	proto.RegisterType((*ReceiptTradeSellLimit)(nil), "types.ReceiptTradeSellLimit")
	proto.RegisterType((*ReceiptSellMarket)(nil), "types.ReceiptSellMarket")
	proto.RegisterType((*ReceiptTradeSellRevoke)(nil), "types.ReceiptTradeSellRevoke")
	proto.RegisterType((*ReqAddrAssets)(nil), "types.ReqAddrAssets")
	proto.RegisterType((*ReqTokenSellOrder)(nil), "types.ReqTokenSellOrder")
	proto.RegisterType((*ReqTokenBuyOrder)(nil), "types.ReqTokenBuyOrder")
	proto.RegisterType((*ReplyBuyOrder)(nil), "types.ReplyBuyOrder")
	proto.RegisterType((*ReplySellOrder)(nil), "types.ReplySellOrder")
	proto.RegisterType((*ReplySellOrders)(nil), "types.ReplySellOrders")
	proto.RegisterType((*ReplyBuyOrders)(nil), "types.ReplyBuyOrders")
	proto.RegisterType((*ReplyTradeOrder)(nil), "types.ReplyTradeOrder")
	proto.RegisterType((*ReplyTradeOrders)(nil), "types.ReplyTradeOrders")
	proto.RegisterType((*ReqSellToken)(nil), "types.ReqSellToken")
	proto.RegisterType((*ReqRevokeSell)(nil), "types.ReqRevokeSell")
	proto.RegisterType((*ReqBuyToken)(nil), "types.ReqBuyToken")
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for Trade service

type TradeClient interface {
	CreateRawTradeSellTx(ctx context.Context, in *TradeForSell, opts ...grpc.CallOption) (*types2.UnsignTx, error)
	CreateRawTradeBuyTx(ctx context.Context, in *TradeForBuy, opts ...grpc.CallOption) (*types2.UnsignTx, error)
	CreateRawTradeRevokeTx(ctx context.Context, in *TradeForRevokeSell, opts ...grpc.CallOption) (*types2.UnsignTx, error)
	CreateRawTradeBuyLimitTx(ctx context.Context, in *TradeForBuyLimit, opts ...grpc.CallOption) (*types2.UnsignTx, error)
	CreateRawTradeSellMarketTx(ctx context.Context, in *TradeForSellMarket, opts ...grpc.CallOption) (*types2.UnsignTx, error)
	CreateRawTradeRevokeBuyTx(ctx context.Context, in *TradeForRevokeBuy, opts ...grpc.CallOption) (*types2.UnsignTx, error)
}

type tradeClient struct {
	cc *grpc.ClientConn
}

func NewTradeClient(cc *grpc.ClientConn) TradeClient {
	return &tradeClient{cc}
}

func (c *tradeClient) CreateRawTradeSellTx(ctx context.Context, in *TradeForSell, opts ...grpc.CallOption) (*types2.UnsignTx, error) {
	out := new(types2.UnsignTx)
	err := grpc.Invoke(ctx, "/types.trade/CreateRawTradeSellTx", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tradeClient) CreateRawTradeBuyTx(ctx context.Context, in *TradeForBuy, opts ...grpc.CallOption) (*types2.UnsignTx, error) {
	out := new(types2.UnsignTx)
	err := grpc.Invoke(ctx, "/types.trade/CreateRawTradeBuyTx", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tradeClient) CreateRawTradeRevokeTx(ctx context.Context, in *TradeForRevokeSell, opts ...grpc.CallOption) (*types2.UnsignTx, error) {
	out := new(types2.UnsignTx)
	err := grpc.Invoke(ctx, "/types.trade/CreateRawTradeRevokeTx", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tradeClient) CreateRawTradeBuyLimitTx(ctx context.Context, in *TradeForBuyLimit, opts ...grpc.CallOption) (*types2.UnsignTx, error) {
	out := new(types2.UnsignTx)
	err := grpc.Invoke(ctx, "/types.trade/CreateRawTradeBuyLimitTx", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tradeClient) CreateRawTradeSellMarketTx(ctx context.Context, in *TradeForSellMarket, opts ...grpc.CallOption) (*types2.UnsignTx, error) {
	out := new(types2.UnsignTx)
	err := grpc.Invoke(ctx, "/types.trade/CreateRawTradeSellMarketTx", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tradeClient) CreateRawTradeRevokeBuyTx(ctx context.Context, in *TradeForRevokeBuy, opts ...grpc.CallOption) (*types2.UnsignTx, error) {
	out := new(types2.UnsignTx)
	err := grpc.Invoke(ctx, "/types.trade/CreateRawTradeRevokeBuyTx", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for Trade service

type TradeServer interface {
	CreateRawTradeSellTx(context.Context, *TradeForSell) (*types2.UnsignTx, error)
	CreateRawTradeBuyTx(context.Context, *TradeForBuy) (*types2.UnsignTx, error)
	CreateRawTradeRevokeTx(context.Context, *TradeForRevokeSell) (*types2.UnsignTx, error)
	CreateRawTradeBuyLimitTx(context.Context, *TradeForBuyLimit) (*types2.UnsignTx, error)
	CreateRawTradeSellMarketTx(context.Context, *TradeForSellMarket) (*types2.UnsignTx, error)
	CreateRawTradeRevokeBuyTx(context.Context, *TradeForRevokeBuy) (*types2.UnsignTx, error)
}

func RegisterTradeServer(s *grpc.Server, srv TradeServer) {
	s.RegisterService(&_Trade_serviceDesc, srv)
}

func _Trade_CreateRawTradeSellTx_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TradeForSell)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TradeServer).CreateRawTradeSellTx(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/types.trade/CreateRawTradeSellTx",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TradeServer).CreateRawTradeSellTx(ctx, req.(*TradeForSell))
	}
	return interceptor(ctx, in, info, handler)
}

func _Trade_CreateRawTradeBuyTx_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TradeForBuy)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TradeServer).CreateRawTradeBuyTx(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/types.trade/CreateRawTradeBuyTx",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TradeServer).CreateRawTradeBuyTx(ctx, req.(*TradeForBuy))
	}
	return interceptor(ctx, in, info, handler)
}

func _Trade_CreateRawTradeRevokeTx_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TradeForRevokeSell)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TradeServer).CreateRawTradeRevokeTx(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/types.trade/CreateRawTradeRevokeTx",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TradeServer).CreateRawTradeRevokeTx(ctx, req.(*TradeForRevokeSell))
	}
	return interceptor(ctx, in, info, handler)
}

func _Trade_CreateRawTradeBuyLimitTx_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TradeForBuyLimit)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TradeServer).CreateRawTradeBuyLimitTx(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/types.trade/CreateRawTradeBuyLimitTx",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TradeServer).CreateRawTradeBuyLimitTx(ctx, req.(*TradeForBuyLimit))
	}
	return interceptor(ctx, in, info, handler)
}

func _Trade_CreateRawTradeSellMarketTx_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TradeForSellMarket)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TradeServer).CreateRawTradeSellMarketTx(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/types.trade/CreateRawTradeSellMarketTx",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TradeServer).CreateRawTradeSellMarketTx(ctx, req.(*TradeForSellMarket))
	}
	return interceptor(ctx, in, info, handler)
}

func _Trade_CreateRawTradeRevokeBuyTx_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TradeForRevokeBuy)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TradeServer).CreateRawTradeRevokeBuyTx(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/types.trade/CreateRawTradeRevokeBuyTx",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TradeServer).CreateRawTradeRevokeBuyTx(ctx, req.(*TradeForRevokeBuy))
	}
	return interceptor(ctx, in, info, handler)
}

var _Trade_serviceDesc = grpc.ServiceDesc{
	ServiceName: "types.trade",
	HandlerType: (*TradeServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateRawTradeSellTx",
			Handler:    _Trade_CreateRawTradeSellTx_Handler,
		},
		{
			MethodName: "CreateRawTradeBuyTx",
			Handler:    _Trade_CreateRawTradeBuyTx_Handler,
		},
		{
			MethodName: "CreateRawTradeRevokeTx",
			Handler:    _Trade_CreateRawTradeRevokeTx_Handler,
		},
		{
			MethodName: "CreateRawTradeBuyLimitTx",
			Handler:    _Trade_CreateRawTradeBuyLimitTx_Handler,
		},
		{
			MethodName: "CreateRawTradeSellMarketTx",
			Handler:    _Trade_CreateRawTradeSellMarketTx_Handler,
		},
		{
			MethodName: "CreateRawTradeRevokeBuyTx",
			Handler:    _Trade_CreateRawTradeRevokeBuyTx_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "trade.proto",
}

func init() { proto.RegisterFile("trade.proto", fileDescriptor0) }

var fileDescriptor0 = []byte{
	// 1246 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xe4, 0x58, 0x41, 0x6f, 0xdb, 0x36,
	0x14, 0x8e, 0x2d, 0xcb, 0xb1, 0x9e, 0x63, 0xc7, 0x61, 0xdd, 0x4c, 0x0d, 0x76, 0x30, 0x84, 0x62,
	0x4b, 0x8b, 0x22, 0xc0, 0x52, 0x14, 0x18, 0xb0, 0x61, 0x43, 0x9c, 0xac, 0x73, 0xb7, 0x16, 0x1b,
	0x18, 0x0f, 0xd8, 0x55, 0xb6, 0xd8, 0x44, 0x88, 0x6c, 0x39, 0x22, 0xd5, 0x58, 0x7f, 0x65, 0x3b,
	0xec, 0xb6, 0xcb, 0xae, 0x03, 0xf6, 0x17, 0x06, 0xec, 0xef, 0xf4, 0x52, 0xec, 0x52, 0x90, 0xa2,
	0x25, 0x4a, 0x96, 0x52, 0x1b, 0xe8, 0x21, 0x4d, 0x6f, 0xe6, 0xe3, 0xe3, 0xc7, 0xa7, 0xef, 0x7b,
	0x8f, 0x7c, 0x26, 0x34, 0x59, 0x60, 0x3b, 0xe4, 0x60, 0x16, 0xf8, 0xcc, 0x47, 0x3a, 0x8b, 0x66,
	0x84, 0xee, 0xed, 0xb0, 0xc0, 0x9e, 0x52, 0x7b, 0xcc, 0x5c, 0x7f, 0x1a, 0xcf, 0x58, 0xaf, 0xab,
	0xa0, 0x0f, 0xb9, 0x27, 0x7a, 0x0c, 0x06, 0x25, 0x9e, 0xf7, 0xdc, 0x9d, 0xb8, 0xcc, 0xac, 0xf4,
	0x2a, 0xfb, 0xcd, 0xc3, 0x3b, 0x07, 0x62, 0xdd, 0x81, 0x70, 0x78, 0xea, 0x07, 0xa7, 0xc4, 0xf3,
	0x06, 0x1b, 0x38, 0xf5, 0x43, 0x87, 0x60, 0x8c, 0xc2, 0xe8, 0x85, 0x1d, 0x5c, 0x10, 0x66, 0x56,
	0xc5, 0x22, 0x94, 0x5b, 0xd4, 0x0f, 0x23, 0xbe, 0x26, 0x71, 0x43, 0x5f, 0x01, 0x04, 0xe4, 0x95,
	0x7f, 0x41, 0x38, 0x9c, 0xa9, 0x89, 0x45, 0xf7, 0x72, 0x8b, 0x70, 0xe2, 0x30, 0xd8, 0xc0, 0x8a,
	0x3b, 0x7a, 0x02, 0x8d, 0x51, 0x18, 0xc5, 0x41, 0xea, 0x62, 0xe9, 0x27, 0xcb, 0xfb, 0x89, 0xe9,
	0xc1, 0x06, 0x4e, 0x5c, 0xf9, 0x9e, 0x3c, 0x68, 0x19, 0x68, 0xbd, 0x70, 0xcf, 0xd3, 0xc4, 0x81,
	0xef, 0x99, 0xba, 0xa3, 0x2f, 0xc1, 0x88, 0x23, 0xe8, 0x87, 0x91, 0xb9, 0x29, 0xd6, 0x9a, 0x85,
	0xf1, 0xca, 0x4f, 0x4d, 0x9c, 0x51, 0x1b, 0xaa, 0x2c, 0x32, 0x6b, 0xbd, 0xca, 0xbe, 0x8e, 0xab,
	0x2c, 0xea, 0x6f, 0x82, 0xfe, 0xca, 0xf6, 0x42, 0x62, 0xfd, 0x5b, 0x85, 0x2d, 0x75, 0x5f, 0xd4,
	0x83, 0x26, 0xf3, 0x2f, 0xc8, 0xf4, 0x34, 0x9a, 0x8c, 0x7c, 0x4f, 0xf0, 0x6f, 0x60, 0xd5, 0x84,
	0x1e, 0xc1, 0x8e, 0x3d, 0xf1, 0xc3, 0x29, 0xfb, 0x99, 0x04, 0x7d, 0xdf, 0x0e, 0x1c, 0xcf, 0x8f,
	0x29, 0xd7, 0xf0, 0xf2, 0x04, 0xc7, 0x9b, 0xb8, 0xd3, 0xc4, 0x4f, 0x13, 0x7e, 0xaa, 0x09, 0x3d,
	0x84, 0xce, 0x2c, 0x70, 0xc7, 0x44, 0x85, 0xab, 0x09, 0xb7, 0x25, 0x3b, 0xba, 0x0f, 0x2d, 0xe6,
	0x33, 0xdb, 0x4b, 0x1c, 0x75, 0xe1, 0x98, 0x35, 0xa2, 0x4f, 0xc1, 0xa0, 0xcc, 0x0e, 0x18, 0x73,
	0x27, 0x44, 0x70, 0xac, 0xe1, 0xd4, 0x80, 0xf6, 0xa0, 0x41, 0x99, 0x3f, 0x13, 0x93, 0x9b, 0x62,
	0x32, 0x19, 0xf3, 0x95, 0xe3, 0xc0, 0xbf, 0x72, 0x5e, 0x86, 0x53, 0xc7, 0x6c, 0xf4, 0x2a, 0xfb,
	0x0d, 0x9c, 0x1a, 0xf8, 0xac, 0x4d, 0x29, 0x61, 0xdf, 0xcd, 0xc9, 0xd8, 0x34, 0x04, 0x33, 0xa9,
	0xc1, 0xfa, 0x1e, 0x9a, 0x8a, 0xf4, 0x68, 0x17, 0xea, 0x5c, 0xba, 0x67, 0x27, 0x92, 0x43, 0x39,
	0xe2, 0x84, 0x8c, 0x64, 0xa0, 0xc7, 0xd3, 0x05, 0x71, 0xaa, 0xc9, 0x7a, 0x04, 0x68, 0x39, 0xfd,
	0xca, 0xf0, 0xac, 0xd7, 0x15, 0xe8, 0xe4, 0x53, 0xee, 0xb6, 0xa8, 0x98, 0xb2, 0x5d, 0xcf, 0xb3,
	0xfd, 0x3c, 0x25, 0x29, 0xad, 0x17, 0xd4, 0x05, 0x7d, 0x14, 0x46, 0x09, 0x47, 0xf1, 0x60, 0x05,
	0xca, 0x1f, 0xc0, 0xce, 0x52, 0x05, 0x15, 0x83, 0x59, 0xff, 0x69, 0x60, 0xf0, 0x1d, 0x7f, 0x0a,
	0x1c, 0x12, 0xac, 0x40, 0xb4, 0x09, 0x9b, 0xb6, 0xe3, 0x04, 0x84, 0x52, 0xb1, 0xb1, 0x81, 0x17,
	0xc3, 0x62, 0x09, 0xb4, 0x15, 0x25, 0xa8, 0xad, 0x26, 0x81, 0xbe, 0xaa, 0x04, 0xf5, 0x22, 0x09,
	0x2c, 0xd8, 0xa2, 0xbe, 0xe7, 0x24, 0x4e, 0x71, 0xb9, 0x64, 0x6c, 0xd9, 0x62, 0x6b, 0x5c, 0x57,
	0x6c, 0xc6, 0x75, 0xc5, 0x06, 0xf9, 0x62, 0x4b, 0xf3, 0xbd, 0x99, 0xa9, 0x1f, 0x6e, 0x67, 0x36,
	0x0b, 0xa9, 0xb9, 0x25, 0x8e, 0x33, 0x39, 0xe2, 0xf6, 0x73, 0xe2, 0x9e, 0x9d, 0x33, 0xb3, 0x25,
	0xf6, 0x91, 0xa3, 0x6c, 0x1a, 0xb5, 0xf3, 0x69, 0xf4, 0xa6, 0x0a, 0xad, 0x45, 0xd5, 0x7c, 0x0c,
	0x8a, 0x7e, 0x06, 0xed, 0x91, 0x1f, 0x9e, 0x9d, 0xb3, 0x9c, 0xa6, 0x39, 0x6b, 0x9a, 0xfb, 0x0d,
	0xb5, 0x90, 0x52, 0xee, 0x8d, 0x12, 0xee, 0xa1, 0x9c, 0xfb, 0x66, 0x9e, 0xfb, 0x3f, 0x35, 0x68,
	0x63, 0x32, 0x26, 0xee, 0x8c, 0xf5, 0xc3, 0xa8, 0x6f, 0x53, 0xb2, 0x02, 0xf9, 0x5d, 0xd0, 0xfd,
	0xab, 0x29, 0x09, 0x24, 0xf5, 0xf1, 0xa0, 0x9c, 0x78, 0xe3, 0xfd, 0x12, 0x6f, 0xdc, 0x08, 0xe2,
	0x0d, 0x95, 0x78, 0x59, 0x24, 0x90, 0x2f, 0x12, 0x36, 0x1f, 0xd8, 0xf4, 0x7c, 0x51, 0x3c, 0xf1,
	0x48, 0x11, 0x6a, 0xab, 0x5c, 0xa8, 0x56, 0x5e, 0xa8, 0xff, 0x35, 0xd8, 0x96, 0x42, 0xf1, 0x93,
	0xef, 0x96, 0x2b, 0x75, 0xf3, 0x0f, 0xbd, 0x54, 0xff, 0x24, 0x5b, 0x5a, 0xb9, 0x6c, 0x91, 0xea,
	0xb7, 0x4b, 0xd4, 0xdf, 0x2e, 0x57, 0xbf, 0x93, 0x57, 0xbf, 0x0f, 0x77, 0xa5, 0xf8, 0xe2, 0x8a,
	0xec, 0x27, 0xfd, 0xf3, 0x03, 0xa8, 0x8d, 0x6c, 0x4a, 0x64, 0x8f, 0x7e, 0x57, 0x76, 0xa2, 0xd9,
	0x8a, 0xc6, 0xc2, 0xc5, 0x3a, 0x82, 0x6e, 0x0e, 0x23, 0xee, 0x53, 0xd6, 0x80, 0x58, 0x0e, 0x23,
	0xbe, 0xa9, 0xd7, 0xc1, 0x38, 0xce, 0x62, 0x9c, 0x26, 0x7f, 0x1f, 0x1e, 0x66, 0x30, 0x76, 0xb3,
	0x18, 0x8b, 0x9c, 0x97, 0x20, 0xdf, 0xc2, 0x8e, 0x32, 0x21, 0xb9, 0x58, 0x07, 0xe0, 0x04, 0x76,
	0xf3, 0x51, 0xc8, 0x4f, 0x59, 0x07, 0xe5, 0x8f, 0x0a, 0xb4, 0x30, 0xb9, 0x3c, 0x72, 0x9c, 0xe0,
	0x88, 0x6b, 0x45, 0x11, 0x82, 0x1a, 0xbf, 0x88, 0x64, 0x2d, 0x8a, 0xdf, 0x4a, 0xe2, 0x54, 0x33,
	0x27, 0x76, 0x17, 0x74, 0x51, 0xab, 0xa6, 0xd6, 0xd3, 0x78, 0xe2, 0x88, 0x01, 0x4f, 0x04, 0xc7,
	0x0d, 0x88, 0xf8, 0x5f, 0x26, 0xff, 0x2d, 0xa4, 0x06, 0xbe, 0x66, 0xcc, 0x0b, 0x54, 0xd4, 0x97,
	0x8e, 0xe3, 0x01, 0xbf, 0x0d, 0x5f, 0x06, 0xfe, 0xe4, 0x47, 0x12, 0xc9, 0x26, 0x6d, 0x31, 0xb4,
	0x7e, 0xaf, 0x70, 0xa6, 0x2e, 0x87, 0xe2, 0x4c, 0x58, 0xaf, 0x63, 0x5a, 0x20, 0x56, 0x33, 0x88,
	0x69, 0x04, 0x9a, 0x1a, 0xc1, 0xf5, 0x51, 0xa7, 0x0c, 0xe8, 0x2a, 0x03, 0xd6, 0x6f, 0x15, 0xe8,
	0x2c, 0xa2, 0xeb, 0x87, 0xd1, 0xcd, 0x0a, 0xee, 0x1f, 0x8d, 0x8b, 0x3b, 0xf3, 0xa2, 0x35, 0x22,
	0x5b, 0xf3, 0xbc, 0xbd, 0xfd, 0x2d, 0xc9, 0x7b, 0xb9, 0x19, 0x3b, 0xa0, 0x5d, 0x90, 0x48, 0x9e,
	0xaf, 0xfc, 0xe7, 0x3b, 0x1a, 0xca, 0xbf, 0x45, 0x53, 0x33, 0xf3, 0xa2, 0x75, 0x32, 0xfe, 0x43,
	0x95, 0x6e, 0x95, 0xab, 0xf2, 0xc3, 0x90, 0x6d, 0xc0, 0x3b, 0x1c, 0x55, 0x35, 0x8a, 0x9e, 0xc4,
	0x4f, 0x35, 0xf1, 0xc8, 0xac, 0xf4, 0xb4, 0xcc, 0xed, 0xa2, 0xfa, 0x62, 0xc5, 0xd1, 0x3a, 0x91,
	0xfa, 0x2f, 0x2a, 0x97, 0xca, 0xb7, 0xa9, 0x0c, 0x4e, 0x57, 0xc5, 0x59, 0x78, 0xe2, 0xd4, 0xcd,
	0x7a, 0xa3, 0xc9, 0x80, 0xc4, 0x15, 0xf1, 0x11, 0x1c, 0x01, 0xe2, 0x95, 0x30, 0x9f, 0x49, 0x39,
	0xeb, 0x4d, 0xca, 0xa5, 0x91, 0xe7, 0x8f, 0x2f, 0x86, 0xbc, 0xc3, 0x6b, 0xc7, 0xed, 0x5f, 0x62,
	0xe0, 0x0c, 0xba, 0x34, 0x49, 0x0e, 0xd1, 0x6b, 0x35, 0xb0, 0x6a, 0x7a, 0x67, 0xc3, 0xd5, 0xc9,
	0x49, 0x4f, 0xd1, 0x01, 0xd4, 0x7d, 0x35, 0x81, 0x76, 0xd5, 0x04, 0x4a, 0x1d, 0xb1, 0xf4, 0xb2,
	0x5e, 0xc0, 0x16, 0x26, 0x97, 0x7c, 0x47, 0x71, 0xc1, 0xa1, 0xcf, 0xa1, 0xc6, 0xbf, 0xfe, 0x9a,
	0xf7, 0x54, 0x2c, 0x1c, 0x8a, 0x53, 0xc8, 0xfa, 0x55, 0xf4, 0x1a, 0xca, 0x6b, 0xd4, 0x17, 0x50,
	0x8f, 0x5f, 0x17, 0x25, 0x62, 0xf9, 0xbb, 0x29, 0x96, 0x8e, 0x25, 0xc8, 0xcf, 0xa0, 0x89, 0xc9,
	0x65, 0x3f, 0x8c, 0xe2, 0x38, 0xef, 0x83, 0x36, 0x0a, 0x23, 0x09, 0x5a, 0xf0, 0x82, 0x8b, 0xf9,
	0xb4, 0xcc, 0x83, 0x14, 0x4a, 0x0c, 0x0e, 0xff, 0xd2, 0x40, 0x17, 0x09, 0x83, 0xbe, 0x81, 0xee,
	0x71, 0x40, 0x6c, 0x46, 0xb0, 0x7d, 0x95, 0xf4, 0x58, 0xc3, 0x39, 0x2a, 0xfa, 0xee, 0xbd, 0x6d,
	0x69, 0xfc, 0x65, 0x4a, 0xdd, 0xb3, 0xe9, 0x70, 0x6e, 0x6d, 0xa0, 0xaf, 0xe1, 0x4e, 0x76, 0x3d,
	0x8f, 0x6f, 0x8e, 0x0a, 0xe2, 0x29, 0x5a, 0xfd, 0x14, 0x76, 0xb3, 0xab, 0x63, 0x32, 0x86, 0x73,
	0x54, 0xce, 0x52, 0x31, 0x8e, 0xb9, 0x14, 0x85, 0x68, 0x57, 0x87, 0x73, 0x54, 0xf6, 0xd8, 0x5c,
	0x84, 0xf3, 0x03, 0xec, 0x2d, 0xb3, 0x11, 0xf7, 0xad, 0x05, 0x31, 0xa5, 0x93, 0x45, 0x58, 0x03,
	0xb8, 0x57, 0xf4, 0x6d, 0x31, 0x3f, 0xa5, 0x8f, 0xd1, 0x05, 0x48, 0xa3, 0xba, 0x78, 0xf7, 0x7f,
	0xfc, 0x36, 0x00, 0x00, 0xff, 0xff, 0x84, 0x9a, 0xb6, 0x92, 0x20, 0x18, 0x00, 0x00,
}
